/*app.factory("httpInterceptor", ['$q', '$rootScope', function ($q, $rootScope) {
    'use strict';
    return {
        'request': function (config) {
            logRequestHeaders(config);
            return config || $q.when(config);
        },
        'requestError': function (rejection) {
            console.error("httpInterceptor:  requestError");
            logRequestHeaders(rejection);
            dealRepeatBlock(true,rejection);        //处理阻塞

            return $q.reject(rejection);
        },
        'response': function (response) {
            console.warn("httpInterceptor: status为    " + response.status);
            logResponseHeaders(response);
            dealRepeatBlock(false,response);        //处理阻塞
//            dealTimeout(response); 					//处理超时
            
            return response || $q.when(response);
        },
        'responseError': function (rejection) {
            console.error("httpInterceptor:  responseError");
            console.error("httpInterceptor: status为    " + rejection.status);
            logResponseHeaders(rejection);

            var isRetry =false;     //是否重发请求进行尝试
            if (rejection.status === 400 || rejection.status === 404) {       //不做处理
            } else if (rejection.status === 501) {
                NC_Util.showMessage(NC_Global.$rootScope, "error", "501 服务器不支持实现请求所需要的功能");
            } else {
                rejection.config.retryCount = rejection.config.retryCount || 0;
                if (rejection.config.retryCount < NC_Config.httpRetryCount) {
                    //设置重发次数
                    rejection.config.retryCount++ ;
                    jsdebug("重发次数：" + rejection.config.retryCount);
                    //重发ajax请求
                    NC_Global.ep.emit(NC_ED["框架_IO_重发ajax请求"], rejection);
                    isRetry = true;
                } else {
                    NC_IOUtil.resetButtonWaitingHttp(rejection.config.curButtonScope);
                    NC_Global.eventHandlers["框架_IO_网络故障"](rejection,NC_Global.$rootScope);
                }
            }

            if(!isRetry){
                dealRepeatBlock(true,rejection);        //处理阻塞
            }
        }
    };
}]);*/
/*
    request: interceptors get called with a http config object. The function is free to modify the config object or create a new one. The function needs to return the config object directly, or a promise containing the config or a new config object.
    requestError: interceptor gets called when a previous interceptor threw an error or resolved with a rejection.
    response: interceptors get called with http response object. The function is free to modify the response object or create a new one. The function needs to return the response object directly, or as a promise containing the response or a new response object.
    responseError: interceptor gets called when a previous interceptor threw an error or resolved with a rejection.
*/
// register the interceptor as a service
app.factory('httpInterceptor', ['$q','$injector','$location','$rootScope',function($q,$injector,$location,$rootScope) {
    return {
        // optional method
        'request': function(config) {
           /* jsdebug("request:");
            angular.forEach(config.headers, function (value, key) {
                jsdebug(key + ":" + value);
            });*/
        	/*var deferred = $q.defer();
        	if($location.path != '/app/login'){
                var url = contextpath+"session-expired.json";
                jsdebug(url);
                var AjaxService = $injector.get("AjaxService");
               AjaxService.$ajax(url, {sessionId:sessionStorage.getItem("sessionId")}).success(function(data) {
              	  deferred.resolve(config);
              	  jsdebug("success");
              	  jsdebug("go");
    	          	if(data.result&&$location.path != '/app/login'){
    	           	 	jsdebug('user is not logged in.');
    	                $location.path('/app/login');
    	           }
                 });
        	}
             return deferred.promise;*/
           /* var SessionService = $injector.get("SessionService");
            SessionService.SessionExpired().then(function(data){
            	if(data.result&&$location.path != '/app/login'){
               	 	jsdebug('user is not logged in.');
                    $location.path('/app/login');
               }
            });*/
           
            /*var deferred = $q.defer();
            var url=contextpath+"login.json"
            $injector.get("AjaxService").$ajax(url, {userId:localStorage.getItem("userid"),password:localStorage.getItem("password"),role:"seller"})
                .success(function(data) {
                    if(data){
                        if(data.result==1){
                            sessionStorage.setItem("userid",data.userid);
                        }
                    }
                    deferred.resolve(config);
            }).error(function(data, status, headers, config) {
                    deferred.resolve(config);
            });*/
            //return deferred.promise;
          /*  var userid = sessionStorage.getItem("userid");
            if(!userid){
                jsdebug("aaa");
                $injector.get('$state').go("app.login");
                //$injector.get('$state').transitionTo('app.login');
            }*/
            // do something on success
        	return config;
        },

        // optional method
        'requestError': function(rejection) {
            // do something on error
            return $q.reject(rejection);
        },



        // optional method
        'response': function(response) {
            // jsdebug("------------------------------------------------------");
            // jsdebug(response);
            $rootScope['ncConfig']={};
            $rootScope['ncConfig']['showLoading']=false;
            /*  jsdebug("response:"+response);
            if(!$rootScope.ttt){
                if(!$rootScope.repeatHttpRequest){
                    $rootScope.$emit('timeoutEvent');
                    jsdebug("mmmmmmmmmmmmmmmmm");
                }
            }*/
            return response;
        },

        // optional method
        'responseError': function(rejection) {
            $rootScope['ncConfig']={};
            $rootScope['ncConfig']['showLoading']=false;
            // do something on error
            return $q.reject(rejection);
        }
    };
}]);
