window.jPushReady = false;
var app = angular.module('app', ['ionic','services','app.services','app.utils']);
app.run(["$ionicPlatform","$rootScope","$location","$ionicHistory","$state","commonService","$timeout",function($ionicPlatform,$rootScope,$location,$ionicHistory,$state,commonService,$timeout) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
      window.plugins.jPushPlugin.init();
      if(typeof($rootScope.loginInfo)=='object' && 'id' in $rootScope.loginInfo){
          window.plugins.jPushPlugin.setAlias('os_'+window.mode+'_'+$rootScope.loginInfo.id);
      }else{
          window.plugins.jPushPlugin.setAlias('');
      }
      window.jPushReady = true;

  });
    $rootScope['toStates']={}
    $rootScope['ncConfig'] = {};
    $rootScope['ncConfig']['showLoading'] = false;
    $rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams, options){
        $rootScope['toStates']=toState;
        $rootScope['fromStates']=fromState;
    });

    $rootScope.$on('timeoutEvent', function(msg, data) {
        $rootScope.repeatHttpRequest=true;
        $timeout(function(){
            $rootScope.repeatHttpRequest=false;
        },2000);
        var stateName="";
        if($rootScope['ncStates']){
            stateName=$rootScope['ncStates'].name;
            if(stateName){
                if(stateName.indexOf("app.home")!=-1){
                    $state.go("app.login");
                }
            }
        }
    });
    $rootScope.loginInfo = commonService.getUserInfo();
    if(!$rootScope.loginInfo){
        $state.go('app.login');
    }

    $rootScope.bagde = {mymsg_cnt:0};

    // 获取自定义消息推送内容
    document.addEventListener("jpush.openNotification", function(event){
        // var extras = event.extras;
        // var type = extras.type;
        // var params = extras.params?extras.params:{};
        // alert(type);
    }, false);
}]);
app.config(['$ionicConfigProvider','$httpProvider',function($ionicConfigProvider,$httpProvider) {
    //$ionicConfigProvider.tabs.position("bottom");
    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.backButton.previousTitleText(false);
    $httpProvider.interceptors.push("httpInterceptor");
}]);


